<?php if(!defined('PLX_ROOT')) exit;
/**
 * Plugin inMyPluxml
 * @package	PLX
 * @version	1.6.0
 * @date	20/12/2018
 * @author	Cyril MAGUIRE, Thomas Ingles
 **/
class inMyPluxml extends plxPlugin {

	/**
	 * Constructeur de la classe inMyPluxml
	 * @param	default_lang	langue par défaut utilisée par PluXml
	 * @return	void
	 * @author	Thomas Ingles
	 **/
	public function __construct($default_lang) {
		if(defined('PLX_ADMIN')){
			parent::__construct($default_lang);# Appel du constructeur de la classe plxPlugin (obligatoire)
			$this->setConfigProfil(PROFIL_ADMIN, PROFIL_MANAGER);# droits pour accèder à la page config.php du plugin
			# Déclarations des hooks
			$this->addHook('plxAdminConstruct', 'plxAdminConstruct');
			$this->addHook('plxAdminEditArticle', 'plxAdminEditArticle');	
			$this->addHook('AdminArticlePrepend', 'AdminArticlePrepend');
			$this->addHook('AdminArticleInitData', 'AdminArticleInitData');
			$this->addHook('AdminArticleParseData', 'AdminArticleParseData');
			$this->addHook('AdminArticleTop', 'AdminArticleButtons');#Cancel publish button (On Foot?)
			$this->addHook('AdminAuthTop', 'AdminAuthTop');
			$this->addHook('AdminAuth', 'AdminBookContent');#backup, notify, exit
			$this->addHook('AdminArticleContent', 'AdminBookContent');#backup, notify, exit
			$this->addHook('AdminProfil', 'showBookMarklet');
			$this->addHook('AdminArticleSidebar', 'showBookMarklet');
		}
	}
	/**
	 * Méthode qui Affiche le(s) BookMarklet(s) config, help, Hook pour Adminprofil, AdminArticleSidebar #v 1.5.0
	 * @return	stdio
	 * @author	Thomas Ingles
	 **/
	public function showBookMarklet(){
		global $plxAdmin;
		$bimp = '✚Xml·';
		$siteImg = '<img src="'.PLX_PLUGINS.__CLASS__ .'/favicon.png" style="width:auto;height:16px!important;">';
		$siteTitleBase = $bimp.$plxAdmin->aConf['title'];
		$siteTitle = $siteImg.$siteTitleBase;
		$icoPath = PLX_PLUGINS.__CLASS__ .'/bookmarklets/img/';
		$alert_text_ShaarlXml = str_replace(array(' ',"'"),array('%20','’'),$this->getLang('L_ALERT'));
?>
	<div class="grid">
		<div class="field col sml-12">
<span><label><img src="<?php echo PLX_PLUGINS.__CLASS__ ?>/favicon.png"><?php echo ucfirst(__CLASS__) ?><a title="<?php echo __CLASS__ ?>?" id="toggler<?php echo __CLASS__ ?>" href="javascript:void(0)" onclick="toggleDiv('<?php echo __CLASS__ ?>','toggler<?php echo __CLASS__ ?>','..?','···')" style="outline:none">..?</a>&nbsp;:</label><i title="<?php $this->lang('_L_BOOKMARKLET') ?>">Bookmarklet</i> -&gt; <a title="<?php echo $bimp.$plxAdmin->aConf['title'] ?>" href="javascript:(function(){
var%20url%20=%20location.href;
var%20title%20=%20document.title%20||%20url;
var%20faction%20=%20'<?php echo plxUtils::getRacine();?>core/admin/auth.php?p=article.php&amp;source=bookmarklet&amp;description=post&amp;head=post&amp;post='%20+%20encodeURIComponent(url)+'&amp;title='%20+%20encodeURIComponent(title);
var%20windowoption='resizable=yes,height=768,width=768,location=0,menubar=0,scrollbars=1';
var%20frm%20=%20document.createElement('form');frm.setAttribute('method','post');frm.setAttribute('action',faction);frm.setAttribute('target','_blank');
var%20winName='inMyPluxml';
try{
var%20tagArts=document.body.getElementsByTagName('article');
var%20tagArt='';if(!!tagArts.length)for(var%20a=0;a<tagArts.length;a++)tagArt=tagArt+tagArts[a].innerHTML.replace(/\s+/g,' ');
tagArt=!!tagArts.length?tagArt:document.body.innerHTML.replace(/\s+/g,' ');
var%20desc=!!document.getSelection().toString()?(!!window.getSelection().getRangeAt(0).commonAncestorContainer.innerHTML?window.getSelection().getRangeAt(0).commonAncestorContainer.innerHTML:document.getSelection().toString().replace(/(?:\r\n|\r|\n)/g,'<br>')):tagArt;
}catch(e){var%20desc=!document.getSelection().toString()?document.body.innerHTML.toString():window.getSelection().toString();}
var%20ea='';var%20mts=document.getElementsByTagName('meta');for(var%20p=0;p<mts.length;p++){ea=ea+mts[p].outerHTML;}
var%20ap=[['description',desc],['char',document.characterSet],['head',ea]];
for(var%20p=0;p<ap.length;p++){var%20hF%20=%20document.createElement('input');hF.setAttribute('type','hidden');hF.setAttribute('name',ap[p][0]);hF.setAttribute('value',ap[p][1]);frm.appendChild(hF);	document.body.appendChild(frm);}
window.open('',winName,windowoption).focus();
frm.target=winName;frm.submit();document.body.removeChild(frm);
})();"><?php echo $siteTitle ?></a></p>
<div id="<?php echo __CLASS__ ?>" style="display:none;"><img src="<?php echo PLX_PLUGINS.__CLASS__ ?>/icon.png"><span style="font-size:66px;line-height:1px;">..?</span>
<p><?php printf($this->getLang('L_CONFIG_TIPS'),$siteTitle,$siteTitle) ?><a title="++<?php echo __CLASS__ ?> Content Security Policy (CSP)?" id="toggler<?php echo __CLASS__ ?>_csp" href="javascript:void(0)" onclick="toggleDiv('<?php echo __CLASS__ ?>_csp','toggler<?php echo __CLASS__ ?>_csp','++?','---')" style="outline:none">++?</a>
<span id="<?php echo __CLASS__ ?>_csp" style="display:none;"><?php $this->lang('L_CONFIG_CSP') ?></span></p>
</span>
</div>
<a title="++<?php echo __CLASS__ ?> ♠ ♣ ♥ ♦ ✓ ✨" id="toggler<?php echo __CLASS__ ?>_books" href="javascript:void(0)" onclick="toggleDiv('<?php echo __CLASS__ ?>_books','toggler<?php echo __CLASS__ ?>_csp','♠ ♣ ♥ ♦ ✓ ✨','---')" style="outline:none">♠ ♣ ♥ ♦ ✓ ✨</a>
<span id="<?php echo __CLASS__ ?>_books" style="display:none;"><h3><i><?php $this->lang('L_BOOKMARKLETS') ?> (Bookmarklets)</i></h3><p><i><?php $this->lang('L_BOOKMARKS_TOOLS') ?>...</i></p><?php include('bookmarklets/searchs.php') ?></span></p>
		</div>
	</div>
	<?php
	}
	/**
	 * Méthode qui ajoute la provenance des données afin de pouvoir fermer automatiquement la fenêtre après l'enregistrement v1.5.0
	 * Et qui conserve la source (description & head) : si erreur password (AdminAuth), d'url ou titre (AdminArticleContent)
	 * @return	stdio
	 * @author	Thomas Ingles
	 **/
	public function AdminBookContent() {
		if( (isset($_GET['source']) AND $_GET['source'] == 'bookmarklet') OR (isset($_POST['source']) AND $_POST['source'] == 'bookmarklet') ){
			echo '	<input type="hidden" name="source" value="bookmarklet" />'.PHP_EOL;
			if  (isset($_GET['one']) AND $_GET['one'] == 'click'){//AdminArticleContent : idea
				//$this->blinkTitleWin();
				//$this->AdminBookJsNotify('loaded', 'focus');//$notice='loaded', $self='focus'
			}
			$bkl = array('post','title');
			foreach($bkl as $oae){
				if( isset($_POST[$oae]) AND !empty($_POST[$oae]) ){
					echo '	<input type="hidden" name="'.$oae.'" value="'.plxUtils::strCheck($_POST[$oae]).'" />'.PHP_EOL;
				}
			}
			$bkl = array('description','head');
			foreach($bkl as $oae){
				if(isset($_GET[$oae]) AND !empty($_GET[$oae]) ){
					$mrt = $_GET[$oae] == 'post'?@$_POST[$oae]:@$_GET[$oae];
					echo '	<textarea style="width:0px;height:0px;display:none;visibility:hidden;" name="'.$oae.'">'.plxUtils::strCheck($mrt).'</textarea>'.PHP_EOL;
				}
			}
			unset($bkl,$oae,$mrt);
			$this->blinkTitleWin();
			$this->AdminBookJsNotify('loaded', 'focus');//$notice='loaded', $self='focus'
		}
	}
	/**
	 * Méthode qui Affiche les boutons : restaurer / annuler* la publication (*néttoie les variables de session) + js v1.5.0
	 * @return	stdio
	 * @author	Thomas Ingles
	 **/
	public function AdminArticleButtons() {
		if(isset($_SESSION['bookmarklet']))://si ok
			$imgbtn = '<img src="'.PLX_PLUGINS.__CLASS__.'/favicon.png" style="">';
			echo'<p id="imp_ops">';
			if(!(isset($_GET['source']) OR isset($_POST['source']))){//RECUP BTN
				echo '<button class="green" style="background-color:lightgreen;" type="button" id="restore_imp" value="1" title="'.$this->getLang('L_RESTORE').' '.@L_ARTICLE .' #'.__CLASS__ .' ('.plxUtils::strCheck($_SESSION['bookmarklet']['title']).')" onclick="Check=confirm(\''.$this->getLang('L_RESTORE_CONF').'\');if(Check==false) {return false;} else {window.location = \'article.php?source=bookmarklet&description=post&one=click&restore=1\'; return false;}">'.$imgbtn.' '.$this->getLang('L_RESTORE') .'</button> ';
			}
			echo '<button class="orange" style="background-color:orange;" type="button" id="cancel_imp" value="1" title="'.$this->getLang('L_CANCEL').' #'.__CLASS__ .'" onclick="Check=confirm(\''.$this->getLang('L_CANCEL_CONF').'\');if(Check==false) {return false;} else {window.location = \'article.php?source=bookmarklet&cancel=1\'; return false;}">'.$imgbtn.' '.$this->getLang('L_CANCEL').'</button></p>';
?>
<script type="text/javascript">//boutons après le titre de l'admin (article.php)
var titleIMP = document.getElementsByClassName('inline-form')[0].firstChild.nextSibling;
if(titleIMP){
 var buttonsIMP = document.getElementById('imp_ops');
 titleIMP.after(buttonsIMP);
}
</script>
<?php
		endif;
	}
	/**
	 * Méthode qui préconfigure le plugin a sa première activation
	 * @return	stdio
	 * @author	Cyril MAGUIRE, Thomas Ingles
	 **/
	public function onActivate() {
		#Paramètres par défaut
		if(!is_file($this->plug['parameters.xml'])) {
			$this->setParam('catName', $this->getLang('L_CAT'), 'cdata');
			$this->saveParams();
		}
	}
	/**
	 * Méthode qui Est la 1ere appelée :) 
	 * Transforme (si besoin ré-encode) les posts en session, supprime les var de session onCancel v1.5.0
	 * Génére un token (auth.php post Fix)
	 * @return	void
	 * @author	Thomas Ingles
	 **/
	public function plxAdminConstruct() {
echo '<?php '; ?>
		if(isset($_SESSION['bookmarklet']) AND isset($_POST['draft'])){# notif brouillon : idea? isset($_POST['publish'])
			$_SESSION['bookstate'] = 'draft';
		}
		if (isset($_GET['source']) AND $_GET['source'] == 'bookmarklet') {
			if (isset($_POST['head'])) {# !isset($_SESSION['bookmarklet']['head'])
				$_SESSION['bookmarklet']['head'] = $_POST['head'];
			}
			if(isset($_GET['one']) AND isset($_GET['title'])){//FIX LOST TITLE (PARTS) BAD REDIRECT (no one (= clic))
				$_SESSION['bookmarklet']['title'] = urldecode($_GET['title']);//(ON 1ST LOGIN):DUE htmlentities on 'auth.php' cnx : header('Location: '.htmlentities($redirect));l
			}
			if(isset($_GET['restore']) AND isset($_SESSION['bookmarklet'])){# Restore
				$_SESSION['info'] = '<br /><i><?php echo __CLASS__ ?> <?php @$this->lang['L_BOOKMARKLET'] ?> <?php @$this->lang['L_RESTORED'] ?></i>';#langue du plugin non chargée
				$bkl = array('post','title','description','head');
				$found = false;
				foreach($bkl as $oae){
					if(isset($_SESSION['bookmarklet'][$oae]) AND !empty($_SESSION['bookmarklet'][$oae]) ){
						$found = true;
						$_GET[$oae] = $_SESSION['bookmarklet'][$oae];//restore posted val
					}
				}
				$_SESSION['bookmarklet'] = array_merge($_SESSION['bookmarklet'],array('found'=>$found,'foundby'=>'session plxAdminConstruct'));
				unset($bkl,$oae,$mrt);
			}
			if(isset($_GET['cancel']) AND isset($_SESSION['bookmarklet'])){# clean & close OR redirect + info
				unset($_SESSION['bookmarklet']);
				#$_SESSION['info'] = '<br /><del><?php echo __CLASS__ ?> <?php @$this->lang['L_BOOKMARKLET'] ?> <?php @$this->lang['L_CANCELED'] ?></del>';#inutile ?
				header( "Refresh:1; url=./", true, 303);
				echo '<meta http-equiv="refresh" content="1;url=./"><script>self.close();</script><i>#<?php echo __CLASS__ ?> ···';
				exit;
			}
			if (isset($_POST['description'])) {# !defined('PLX_AUTH');??? !isset($_SESSION['bookmarklet']['description'])
				if( isset($_POST['char']) AND !empty($_POST['char']) ){
					if( strtoupper(PLX_CHARSET) != strtoupper($_POST['char']) ){# RECODE TO GOOD CHARSET : FIX plxUtils::strCheck($description) Windows-2282 to UTF-8
						if (function_exists('mb_convert_encoding')){
							$_POST['title'] = mb_convert_encoding($_POST['title'], PLX_CHARSET, $_POST['char']);
							$_POST['description'] = mb_convert_encoding($_POST['description'], PLX_CHARSET, $_POST['char']);
						}
						elseif (function_exists('utf8_decode')){
							$_POST['title'] = mb_convert_encoding($_POST['title'], PLX_CHARSET, $_POST['char']);
							$_POST['description'] = PLX_CHARSET!='UTF-8'?utf8_decode($_POST['description']):utf8_encode($_POST['description']);
						}
					}
				}
				//maybe clean dom here? //echo @$_POST['char'];echo @$_POST['description'];exit('imp plxAdminConstruct000');
				$_SESSION['bookmarklet']['description'] = $_POST['description'];
				//fix auth token error pluxml 5.2 to 5.7 (+?)
				$token = sha1(mt_rand(0, 1000000));
				$_SESSION['formtoken'][$token] = time();
				$_POST['token'] = $token;
				
				if(!empty($_GET['post']) AND !empty($_GET['title'])) {# 2clic2save Xml bookmarklet
					if( isset($_SESSION['domain']) AND isset($_SESSION['user']) AND isset($_SESSION['hash']) ){
						if($this->aUsers[$_SESSION['user']]['active'] OR !$this->aUsers[$_SESSION['user']]['delete']){
							$_SESSION['bookmarklet']['title'] = $_GET['title'];//#TEP LOST TITLE
							$redirect = 'article.php?source=bookmarklet&post='.urlencode($_GET['post']).'&title='.urlencode(@$_GET['title']).'&description='.urlencode(@$_GET['description']).'&one=click';//post 1.5.x
							#$_SESSION['info'] = '<br /><?php echo __CLASS__ . __FUNCTION__ ?> # 2clic2save post redirected : <br />'.$redirect;exit('redirect: '.$redirect);#debug test
							Header('Location: '.$redirect);
							exit;
						}
					}
				}
			}
# 2clic2save 1.6.0 shaarlXml bookmarklet : get desc
			if(strpos($_SERVER['PHP_SELF'], 'auth') !== false AND !empty($_GET['description']) AND $_GET['description'] !='post' AND !empty($_GET['title'])) {
				if( isset($_SESSION['domain']) AND isset($_SESSION['user']) AND isset($_SESSION['hash']) ){
					if($this->aUsers[$_SESSION['user']]['active'] OR !$this->aUsers[$_SESSION['user']]['delete']){
						$redirect = 'article.php?source=bookmarklet&post='.urlencode($_GET['post']).'&title='.urlencode(@$_GET['title']).'&description='.urlencode(@$_GET['description']).'&one=click';//basic 1.6.0 intest
						#$_SESSION['info'] = '<br /><?php echo __CLASS__ . __FUNCTION__ ?> # 2clic2save shaarlXml redirected : <br />'.$redirect;#debug test
						Header('Location: '.$redirect);
						exit;
					}
				}
			}
# 1.6.0 #TEP good query afer login
			if(strpos($_SERVER['PHP_SELF'], 'auth.php') === false AND !isset($_GET['one']) AND isset($_GET['source']) AND $_GET['source'] == 'bookmarklet'){
				$lru_esrap = parse_url(str_replace('&amp;','&',$this->path_url));
				parse_str(html_entity_decode($lru_esrap['query']), $_GET);//overide $_GET's
				#$_SESSION['info'] = '<br /><?php echo __CLASS__ . __FUNCTION__ ?> # good query afer login gets: <br />'.implode(',<br />',$_GET);#debug test
			}

		}
?><?php
	}
	/**
	 * Méthode permettant de créer une copie locale des images du contenu principal
	 * rec_img($text,$dir)
	 * @param $text string le texte dont il faut transformer les images
	 * @param $dir string le dossier dans lequel on enregistre les images
	 * @return void
	 * @author Cyril MAGUIRE, Thomas Ingles
	 */
	public function plxAdminEditArticle() {//($content, &$id)
echo '<?php '; ?>
		if (isset($_SESSION['bookmarklet'])/* OR (isset($_POST['source']) AND $_POST['source']=='bookmarklet') */) {
			include(PLX_PLUGINS.'<?php echo __CLASS__ ?>/functions.php');
			$content['content'] = rec_img(plxUtils::cdataCheck(trim($content['content'])),plxUtils::title2filename(plxUtils::cdataCheck(trim($content['title']))));
			//$_SESSION['bookmarklet']['id'] = $id;#MAYBE
		}
?><?php
	}
	/**
	 * Méthode qui notifie et ferme automatiquement la fenêtre après l'enregistrement sans erreur
	 * @return	stdio // If no error & we are called from the bookmarklet, we must notify & close the popup:
	 * @author	Thomas Ingles
	 **/
	public function AdminArticleParseData() {// & AdminArticlePostData() ?
		if( isset($_SESSION['bookmarklet']) OR (isset($_POST['source']) AND $_POST['source'] =='bookmarklet') ){
			if(isset($_SESSION['error']))
				$this->AdminBookJsNotify('error','focus');
			else
				$this->AdminBookJsNotify();//success close
		}
	}
	/**
	 * Méthode qui ajoute l'url à sauvegarder dans le formulaire d'authentification
	 * @return	stdio
	 * @author	Cyril MAGUIRE, Thomas Ingles
	 **/
	public function AdminAuthTop() {
echo '<?php '; ?>
		if(!empty($_GET['post']) AND !empty($_GET['title']) AND $_GET['source'] == 'bookmarklet') {
			$redirect .='?source=bookmarklet&post='.urlencode($_GET['post']).'&title='.urlencode(@$_GET['title']).'&description='.urlencode(@$_GET['description']).'&head='.urlencode(@$_GET['head']);
			if(!isset($_GET['one']) AND isset($_GET['title']) AND !isset($_SESSION['bookmarklet']['title']) ){
				$_SESSION['bookmarklet']['title'] = urldecode($_GET['title']);//FIX LOST TITLE (PARTS) AUTH BAD REDIRECT (ON 1ST LOGIN)	header('Location: '.htmlentities($redirect));
			}
		}
?><?php
	}
	/**
	 * Méthode qui crée la catégorie par défaut si elle n'existe pas
	 * @return	stdio
	 * @author	Cyril MAGUIRE, Thomas Ingles
	 **/
	public function AdminArticlePrepend() {
echo '<?php '; ?>
		foreach($plxAdmin->aCats as $cat_id => $cat_name) {
			if ($cat_name['name'] == '<?php echo $this->getParam('catName')?>') {
				$alreadyExists = true;
				$catId = $cat_id;
				break;
			} else {
				$alreadyExists = false;
			}
		}
		if ($alreadyExists === false) {
			$_POST['new_category'] = true;
			$_POST['new_catname'] = '<?php echo $this->getParam('catName')?>';
		}
		# Ajout d'une catégorie
		if(isset($_POST['new_category'])) {
			# Ajout de la nouvelle catégorie
			$plxAdmin->editCategories($_POST);
			# On recharge la nouvelle liste
			$plxAdmin->getCategories(path('XMLFILE_CATEGORIES'));
			unset($_POST['new_category']);
			unset($_POST['new_catname']);
		}

		if ( !isset($_GET['a']) AND !isset($_SESSION['bookmarklet']) AND isset($_POST['source']) ){# Restaure une session perdue
			$_SESSION['bookmarklet'] = TRUE;//
		}
?><?php
	}
	/**
	 * Méthode qui initialise les variables d'un article
	 * @return	void
	 * @author	Cyril MAGUIRE, Thomas Ingles
	 **/	
	public function AdminArticleInitData() {
		echo '<?php '; ?>

		if ( !isset($_GET['a']) AND isset($_SESSION['bookmarklet']) ){#Restaure une session perdue? #TEP
			if(!isset($_GET['source']) AND !isset($_SESSION['bookmarklet']) ){#ANORMAL
				if(isset($_POST['description'])){#ANORMAL
					$bkl = array('post','title','description','head');
					$found = false;
					foreach($bkl as $oae){
						if(isset($_POST[$oae]) AND !empty($_POST[$oae]) ){
							$found = true;
							$_GET[$oae] = $_POST[$oae];//restore posted val
						}
					}
					if($found) $_GET['source'] = 'bookmarklet';
					$_SESSION['bookmarklet'] = array('found'=>$found,'foundby'=>'post');
					unset($bkl,$oae,$mrt);
				}
			}
		}
		if (isset($_GET['source']) AND $_GET['source'] == 'bookmarklet') {#Bookmrklet






			$_GET['post'] = isset($_GET['amp;post'])?$_GET['amp;post']:@$_GET['post'];//fix url & title
			$_GET['title'] = isset($_GET['amp;title'])?$_GET['amp;title']:@$_GET['title'];//fix title
			$_GET['description'] = isset($_GET['amp;description'])?$_GET['amp;description']:@$_GET['description'];//fix description Choice
			$_GET['head'] = isset($_GET['amp;head'])?$_GET['amp;head']:@$_GET['head'];//fix head Choice
			//core/admin/article.php?source=bookmarklet
			if(empty($_GET['post'])) return;//fix test ( ! ) Notice: Undefined index: post in /var/www/0.src.blogs/PluXml/core/admin/article.php(232) : eval()'d code on line 7

			$tsop = explode('&title',$_GET['post']);//explode('&title',$_GET['amp;post']);
			$post = $_GET['post'] = trim($tsop[0]);//$_GET['amp;post'] = $tsop[0];
			$title = isset($tsop[1])?ltrim($tsop[1],'='):$post;


			$meta_tags['description'] = $meta_tags['keywords'] = '';
			if(!isset($_GET['description'])){//utilisé retro compat bookmarklet <=1.3.1 (file_get_contents ur)
				$options = array('http' => array('user_agent' => 'poche'));
				$context = stream_context_create($options);
				$json = @file_get_contents(plxUtils::getRacine(). 'plugins/<?php echo __CLASS__?>/3rdparty/makefulltextfeed.php?url='.urlencode($_GET['post']).'&max=5&links=preserve&exc=&format=json&submit=Create+Feed', false, $context);
				$content = json_decode($json, true);
				$title = $content['rss']['channel']['item']['title'];
				$body = $content['rss']['channel']['item']['description'];
				$_SESSION['bookmarklet']['description'] = $body;
			}else{

				$title = trim(@$_GET['title']);#+1.4.0
//				$title = (isset($_SESSION['bookmarklet']['title'])?$_SESSION['bookmarklet']['title']:(isset($_POST['title'])?$_POST['title']:trim($_GET['title'])));
				$title = (empty($title)?(isset($_POST['title'])?$_POST['title']:(isset($_SESSION['bookmarklet']['title'])?$_SESSION['bookmarklet']['title']:$post)):$title);#1.6.0

				$_SESSION['bookmarklet']['description'] = (isset($_SESSION['bookmarklet']['description'])?$_SESSION['bookmarklet']['description']:(!isset($_POST['description'])?'':$_POST['description']));
				$_SESSION['bookmarklet']['head'] = (isset($_SESSION['bookmarklet']['head'])?$_SESSION['bookmarklet']['head']:(!isset($_POST['head'])?'':$_POST['head']));

				if(!empty($_SESSION['bookmarklet']['head'])){// meta name="description" content= , meta name="keywords" content=
					$metas = $plxAdmin->plxPlugins->aPlugins['<?php echo __CLASS__ ?>']->getMetaTags($_SESSION['bookmarklet']['head']);//['description']//['keywords']
					$meta_tags = array_merge($meta_tags ,$metas);
				}

				if(!empty($_GET['description'])){#+1.4.0
				 	if($_GET['description'] == 'post'){# 1.5.x description=post &(amp;)head=post
						$body = $plxAdmin->plxPlugins->aPlugins['<?php echo __CLASS__ ?>']->cleanDom();//USE $_GET['post'], $_SESSION['bookmarklet']['description'] : return clean imp_description
					}
					else{#1.6.0 shaarlXml
						$body = $_GET['description'];
						$_SESSION['bookmarklet']['description'] = $body;
					}
				}
				
			}
			# Alimentation des variables
			$artId = '0000';
			$author = $_SESSION['user'];
			foreach($plxAdmin->aCats as $cat_id => $cat_name) {
				if ($cat_name['name'] == '<?php echo $this->getParam('catName')?>') {
					if (isset($catId) AND is_array($catId)) {
						$catId[] = $cat_id;
					} else {
						$catId = array();
						$catId[] = $cat_id;
					}
					break;
				}
			}
			$date = array ('year' => date('Y'),'month' => date('m'),'day' => date('d'),'time' => date('H:i'));
			$chapo = (!empty($meta_tags['description'])?'<p>'.$meta_tags['description'].'</p>':'').'<p>Source : <a href="'.$post.'">'.$post.'</a></p>';
			$content =  $body;
			if(!empty($meta_tags['keywords'])){//clean keywords
				$meta_tags['keywords'] = explode(',',str_replace(array(' ,',', ',' - '),',',strtolower($meta_tags['keywords'])));
				$meta_tags['keywords'] = array_unique($meta_tags['keywords'], SORT_STRING);
				$meta_tags['keywords'] = implode(',',$meta_tags['keywords']);
				$meta_tags['keywords'] = str_replace(' ,',',',$meta_tags['keywords']);
			}
			$tags = $meta_tags['keywords'];
			$url = '';
			$allow_com = $plxAdmin->aConf['allow_com'];
			$template = 'article.php';
			$meta_description = $meta_tags['description'];
			$meta_keywords = $tags;
			$title_htmltag = '';
			if(empty($title)) {
				$title = isset($_GET['title'])?trim($_GET['title']):$post;# view-source: fix //o : $title = trim($_GET['amp;title']); 1.5.x
				#$title = isset($_GET['title'])?trim($_GET['title']):(isset($_POST['title'])?trim($_POST['title']):$post);# view-source: fix //o : $title = trim($_GET['amp;title']);
			}
			//$_SESSION['bookmarklet'] = true;
			$_SESSION['bookmarklet'] = array_merge($_SESSION['bookmarklet'],array('post'=>$post,'title'=>$title));//,'meta_description'=>$meta_description,'tags'=>$tags
		}
?><?php
	}
	/**
	 * Méthode qui affiche le javascript des notif navi après l'enregistrement/Ouverture sans erreur
	 * @param	$notice		L_NOTIFY_$notice.upper : (success, loaded)
	 * @param	$self 		notifs mode self mode (window js DOM) : close, focus, ...
	 * @return	stdio
	 * @author	Thomas Ingles
	 **/
	public function AdminBookJsNotify($notice='success', $self='close') {
		$jSelfHeight = ($self!='close')?768:320;
		$impId = $state = $bookstate = '';
		if(isset($_GET['a'])){//IS_NUMBER?
			unset($_SESSION['bookmarklet']);
			$impId = 'N°'.intval(@$_GET['a']);
			if(isset($_SESSION['bookstate'])){
				$bookstate = $_SESSION['bookstate'];
			}
			$state = ' #'.L_ARTICLE_STATUS.' ('.($bookstate=='draft'?L_DRAFT:L_PUBLISHED).')';
//idea 1 if($notice=='success' OR $self=='close')//only SUCCESS, change size & vibrate? ;)
?>
<script style="display:none" id="window_focus" type="text/JavaScript">
// <![CDATA[
try{
 window.navigator.vibrate(200);
}catch(e){console.log('vibrate error : '+e);}
//if(window.innerWidth==768)
 window.innerHeight=<?php echo $jSelfHeight; ?>;
//window.focus//window.minimize();// exist??? (is success to hide popup window before close)
// ]]>
</script>
<?php
			$pmmUrlFront = $link = '';
			# Si plugin plxMyMultilingue présent
			if(defined('PLX_MYMULTILINGUE')) {
				$lang = plxMyMultiLingue::_Lang();# récupération de la langue en cours
				if(!empty($lang)) {
					if(isset($_SESSION['data_lang'])){
						//  (isset($_SESSION['default_lang']) AND $_SESSION['default_lang']!=$lang)//public
						if($_SESSION['data_lang']!=$lang){//admin
							$pmmUrlFront = $lang.'/';
						}
						if(isset($_SESSION['default_lang']) AND $_SESSION['default_lang'] != $_SESSION['data_lang']){//admin $_SESSION['lang']
							$pmmUrlFront = $lang.'/';//Pour "Voir"
						}
					}
				 }
			}
			#$link = 'article'.intval($_GET['a']);//$link = $plxAdmin->urlRewrite('?'.$pmmUrlFront.$link);//Notice: Undefined variable: plxAdmin
			$link = ($bookstate=='draft')?$_SERVER['PHP_SELF'].'?a='.$_GET['a']:PLX_ROOT.'?'.$pmmUrlFront.'article'.intval($_GET['a']);
		}//FI isset($_GET['a']))
		unset($_SESSION['bookstate']);
		$mixtxt = '#'.L_ARTICLE.($notice!='success'?' ':$impId).$state;//.' '.trim(@$_POST['title']);
		$notify = '#'.__CLASS__.' : '.(isset($_SESSION['info'])?$_SESSION['info']:' '.@$_SESSION['error']).'","'.$mixtxt.'\n'.$this->getLang('L_NOTIFY_CLIC_HERE_TO').' '.$this->getLang('L_VIEW_'.strtoupper($notice)).'\n\n'.$this->getLang('L_WIN_'.strtoupper($notice)). '...';
		if(isset($_SESSION['info']) AND ($notice=='success')){//GET a (David, ok j->)
		 $_SESSION['info'] = '#'.__CLASS__.'<br />'.$_SESSION['info'].'<br />'.$this->getLang('L_MSG_SUCCESS').'<br />'.str_replace('\n','<br />',$mixtxt);
		}
?>
<script style="display:none" id="window_notify" type="text/JavaScript">
// <![CDATA[
// NO menu bar
if(!window.menubar.visible){// visible = 0 inMyPlux window (maybe) : Fix.a : if use another edit window for edit art (when save & $_SESSION bookmaklet is set = close window (with all tabs opened) :/)
	var notifs = false;
	var phrase = ["<?php echo $notify ?>"];
	try{//fix 0ld navi android bug
		if(typeof Notification !== 'undefined')//in PHP == isset() ;)
			notifs = Notification;
	}catch(e){
		console.log('Notification Error',e);
		self.<?php echo $self ?>();
	}
	function notifyMe(title,body){//Or not (simply close)
		if (!!notifs && !!notifs.permission && !notifs.permission !== "granted"){
			var notification = new Notification(title,{icon:'<?php echo PLX_PLUGINS.__CLASS__ ?>/iconify.png',body:body});
			try{
				notification.onshow = function(){window.setTimeout(function(){self.<?php echo $self ?>()},5555);};
	<?php if(isset($_GET['a'])){ ?>
				var aUrl = '<?php echo $link ?>';
				notification.onclick = function () {window.open(aUrl);};// see art on anther window
	<?php }//FI isset($_GET['a'])) ?>
				notification.onclose = function(){console.log('notification onclose() called = self.<?php echo $self ?>() after 1618ms.');window.setTimeout(function(){self.<?php echo $self ?>();},1618);};
				notification.onError = function(){window.setTimeout(function(){console.log('Notification onError',notification);},345);};
			}catch(e){
				console.log('Notification Error',e);
			}
		}else
			self.<?php echo $self ?>();
	}

	if(!!notifs && !!notifs.permission && notifs.permission !== "granted"){
		//document.addEventListener('DOMContentLoaded',function(){//ff63 say L’attribut « content » des objets Window est obsolète. Veuillez utiliser « window.top » à la place. est-ce cela?
			if(notifs.requestPermission().then){//FIX Uncaught TypeError: Cannot call method 'then' of undefined 
				notifs.requestPermission().then(function(result) {//result : 'default' 'denied' 'granted'
					if('granted' == result){notifyMe(phrase[0],phrase[1]);}
					else self.<?php echo $self ?>();
				});//fi notifs.requestPermission().then()
			}else if(notifs.requestPermission()){//request permission on page load ,if need
				notifyMe(phrase[0],phrase[1]);
			}
		//});//addEventListener('DOMContentLoaded
	}else if(notifs){
		notifyMe(phrase[0],phrase[1]);
	}else{
		self.<?php echo $self ?>();
	}
}
// ]]>
</script>
<?php
	}
	/**
	 * Méthode qui Permute le titre de la fenêtre v1.5.0
	 * @return	stdio
	 * @author	Thomas Ingles
	 **/
	public function blinkTitleWin() {
?>
<script style="display:none" id="blinkTitleWin" type="text/JavaScript">
// <![CDATA[
var oldTitle = document.title;
var msg = "#<?php echo __CLASS__ ?> ··· ";
var timeoutId = false;
var blink = function() {
	document.title = document.title == oldTitle ? msg+oldTitle : oldTitle;//Modify Title in case a popup
	if(document.hasFocus()){//Stop blinking and restore the Application Title
		document.title = oldTitle;
		clearInterval(timeoutId);
	}                       
};
if(!timeoutId){
	timeoutId = setInterval(blink, 1111);//Initiate the Blink Call
}//Blink logic 
// ]]>
</script>
<?php
	}
	/*
	* usage : $meta_tags = getMetaTags($string); : return (array) v1.5.0
	* This regex gets meta tags independent of sequence by capturing inside a lookahead.
	* Further uses the branch reset feature for different quote styles of values.
	* The pattern can be tested here: https://regex101.com/r/oE4oU9/1
	*/
	public function getMetaTags($str){#src : php.net/manual/en/function.get-meta-tags.php#117766
		$pattern = '
~<\s*meta\s(?=[^>]*?\b(?:name|property|http-equiv)\s*=\s*(?|"\s*([^"]*?)\s*"|\'\s*([^\']*?)\s*\'|([^"\'>]*?)(?=\s*/?\s*>|\s\w+\s*=)))
  [^>]*?\bcontent\s*=\s* (?|"\s*([^"]*?)\s*"|\'\s*([^\']*?)\s*\'|([^"\'>]*?)(?=\s*/?\s*>|\s\w+\s*=))[^>]*>~ix';
		$return = array();
		try{
			error_reporting(E_ERROR);
			if(preg_match_all($pattern, $str, $out))
				$return = array_combine($out[1], $out[2]);
		}catch(Exception $err){}
		error_reporting(E_ERROR | E_WARNING | E_PARSE | E_NOTICE);
		return $return;
	}
	/**
	 * Méthode qui Fixe les url relatives en absolute et nettoie le DOM HTML Posté par le Bookmarklet v1.5.0
	 * @return	void
	 * @author	Thomas Ingles
	 **/
	public function cleanDom($post='', $body='') {
		$body = !empty($body)?$body:$_SESSION['bookmarklet']['description'];# idea
		$post = !empty($post)?$post:$_GET['post'];# idea
		//remove script style tags
		$body = preg_replace('#<script(.*?)>(.*?)</script>#is', '', $body);//remove script tags
		$body = preg_replace('#<style(.*?)>(.*?)</style>#is', '', $body);//remove style tags
		//Transform H1
		$body = str_replace(array('<h1','</h1'),array('<h2','</h2'), $body);//change h1 tags to h2
		//remove HTML tags : aside, dialog, div, form, input, label, legend, link, span, textarea, script, style, var, button ...
		$body = strip_tags($body, '<a><abbr><address><area><article><audio><b><base><bdi><bdo><blockquote><br><canvas><caption><cite><code><col><colgroup><data><datalist><dd><del><details><dfn><dl><dt><em><embed><fieldset><figcaption><figure><footer><h2><h3><h4><h5><h6><header><hgroup><hr><i><iframe><img><ins><li><main><p><pre><q><rb><rp><rt><rtc><ruby><s><samp><section><small><source><strong><sub><summary><sup><table><tbody><td><template><tfoot><th><thead><time><title><tr><track><u><ul><video><wbr>');
		$body = trim($body);

		//remove attributes
		$search = array('style','class','id','style','on(.*?)','data-(.*?)');
		foreach($search as $attr){
			$body = preg_replace('# '.$attr.'="(.*?)"#is', '', $body);
			$body = preg_replace("# ".$attr."='(.*?)'#is", '', $body);
		}

		//youtube cleaner 
		$body = preg_replace('~\[\[(.*?)\]\]~is', '', $body);//remove /ex: [[getSimpleString(data.actionMessage)]]
		$body = preg_replace('~\{\{(.*?)\}\}~is', '', $body);//remove /ex: {{label}} 
		$body = str_replace('&nbsp;',' ', $body);//&nbsp; to ' '

		//stackoverflow.com/a/29176679 : Regex by Alejandro Salamanca Mazuelo to remove all empty HTML tags
		do {
			$tmp = $body;
			$body = preg_replace( '#<([^ >]+)[^>]*>([[:space:]]|&nbsp;)*</\1>#', '', $body );
		} while ( $body !== $tmp );
		unset($tmp);

		//Idea to 
		$iMPHost = $iMPSchm = '';
		$iMPHost = explode('//',$post);
		if(isset($iMPHost[1])){
			$iMPSchm = $iMPHost[0];

			$iMPHost = explode('/',$iMPHost[1]);

			end($iMPHost);
			$lk = key($iMPHost);
			reset($iMPHost); 
			if(strpos($iMPHost[$lk],'.') !== FALSE)
				unset($iMPHost[$lk]);

			$iMPPath = implode('/',$iMPHost);

			$iMPHost = $iMPHost[0];

			$body = str_replace('src="//', 'src="'.$iMPSchm.'//', $body);
			$body = str_replace("src='//", "src='".$iMPSchm.'//', $body);
			$body = str_replace('src="/', 'src="'.$iMPSchm.'//'.$iMPHost.'/', $body);
			$body = str_replace("src='/", "src='".$iMPSchm.'//'.$iMPHost."/", $body);

			//relative without / : https://www.cgsecurity.org/euro/ + !yt img fix
			if(strpos($body, 'src="'.$iMPSchm.'//') === FALSE){
				$body = str_replace('src="', 'src="'.$iMPSchm.'//'.$iMPPath.'/', $body);
			}
			if(strpos($body, "src='".$iMPSchm.'//') === FALSE){
				$body = str_replace("src='", "src='".$iMPSchm.'//'.$iMPPath."/", $body);
			}

			$body = str_replace('href="//', 'href="'.$iMPSchm.'//', $body);
			$body = str_replace("href='//", "href='".$iMPSchm.'//', $body);
			$body = str_replace('href="/', 'href="'.$iMPSchm.'//'.$iMPPath.'/', $body);
			$body = str_replace("href='/", "href='".$iMPSchm.'//'.$iMPPath."/", $body);

			//relative without / : https://www.cgsecurity.org/euro/
			if(strpos($body, 'href="'.$iMPSchm.'//'.$iMPHost.'/') === FALSE){
				$body = str_replace('href="', 'href="'.$iMPSchm.'//'.$iMPPath.'/', $body);
			}
			if(strpos($body, "href='".$iMPSchm.'//'.$iMPHost."/") === FALSE){
				$body = str_replace("href='", "href='".$iMPSchm.'//'.$iMPPath."/", $body);
			}
			unset($iMPHost,$iMPSchm);
		}
		return $body;
	}

}
